﻿Public Class MainAccountRecForm

    Private m_objVaxUserAgent As cVaxSIPUserAgentExCOM
    Private m_bBtnAdvanceShow As Boolean = True

    Public Sub New(ByRef objVaxUserAgent As cVaxSIPUserAgentExCOM)
        InitializeComponent()
        m_objVaxUserAgent = objVaxUserAgent
    End Sub

    Private Sub MainAccountRecForm_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        LoadAccountData()
    End Sub

    Private Sub BtnOnline_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnOnline.Click

        If BtnOnline.Text = "Offline" Then

            m_objVaxUserAgent.UnRegisterAccountREC()
            BtnOnline.Text = "Online"

            Return

        End If

        If EditAuthLogin.Text = "" Then
            MessageBox.Show("Invalid auth Login.", "VaxVoIP SDK", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        If EditServerAddr.Text = "" Then
            MessageBox.Show("Invalid SIP server domain or IP address.", "VaxVoIP SDK", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        cStoreAccountREC.AddAccountInfo(EditDisplayName.Text, EditUserName.Text, EditAuthLogin.Text, EditAuthPwd.Text, EditDomainRealm.Text, EditServerAddr.Text, Convert.ToInt32(EditServerPort.Text), CheckRegisterToServerREC.Checked)

        If Not m_objVaxUserAgent.RegisterAccountREC(CheckRegisterToServerREC.Checked, EditDisplayName.Text, EditUserName.Text, EditAuthLogin.Text, EditAuthPwd.Text, EditDomainRealm.Text, EditServerAddr.Text, Convert.ToInt32(EditServerPort.Text)) Then
            Return
        End If

        If CheckRegisterToServerREC.Checked Then
            AddToStatusLog("Registering to SIP Server REC")
        End If

        BtnOnline.Text = "Offline"

    End Sub

    Private Sub BtnAdvance_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnAdvance.Click

        If m_bBtnAdvanceShow Then

            LabelDisplayName.Visible = True
            LabelUserName.Visible = True

            LabelDomain.Visible = True
            EditDisplayName.Visible = True

            EditUserName.Visible = True
            EditDomainRealm.Visible = True

            BtnAdvance.Text = "Basic"
            m_bBtnAdvanceShow = False

            Return
        End If

        LabelDisplayName.Visible = False
        LabelUserName.Visible = False

        LabelDomain.Visible = False
        EditDisplayName.Visible = False

        EditUserName.Visible = False
        EditDomainRealm.Visible = False

        BtnAdvance.Text = "Advance"
        m_bBtnAdvanceShow = True

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnClearStatusLog_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnClearStatusLog.Click
        ListBoxStatusLog.Items.Clear()
    End Sub

    Private Sub btnClearCallLog_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnClearCallLog.Click
        ListBoxCallLog.Items.Clear()
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Private Sub AddToStatusLog(ByVal sStatus As String)

        ListBoxStatusLog.Items.Add(sStatus)
        ListBoxStatusLog.TopIndex = ListBoxStatusLog.Items.Count - 1

    End Sub

    Private Sub AddToCallLog(ByVal sStatus As String)

        ListBoxCallLog.Items.Add(sStatus)
        ListBoxCallLog.TopIndex = ListBoxStatusLog.Items.Count - 1

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Private Sub LoadAccountData()

        Dim sDisplayName As String = ""
        Dim sUserName As String = ""

        Dim sAuthLogin As String = ""
        Dim sAuthPwd As String = ""

        Dim sDomainRealm As String = ""
        Dim sServerAddr As String = ""

        Dim nServerPort As Integer = 5060
        Dim bRegisterREC As Boolean = True

        cStoreAccountREC.GetAccountInfo(sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort, bRegisterREC)

        EditDisplayName.Text = sDisplayName
        EditUserName.Text = sUserName

        EditAuthLogin.Text = sAuthLogin
        EditAuthPwd.Text = sAuthPwd

        EditDomainRealm.Text = sDomainRealm
        EditServerAddr.Text = sServerAddr
        EditServerPort.Text = Convert.ToString(nServerPort)

        CheckRegisterToServerREC.Checked = bRegisterREC

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnConnectingToRegister()
        AddToStatusLog("Connecting to register.")
    End Sub

    Public Sub OnTryingToRegister()
        AddToStatusLog("Trying to register.")
    End Sub

    Public Sub OnFailToRegister(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        AddToStatusLog("Failed: " & sReasonPhrase)
    End Sub

    Public Sub OnSuccessToRegister()
        AddToStatusLog("Success to register.")
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnTryingToReRegister()
        AddToStatusLog("Trying to Re-Register.")
    End Sub

    Public Sub OnFailToReRegister(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        AddToStatusLog("Failed: " & sReasonPhrase)
    End Sub

    Public Sub OnSuccessToReRegister()
        AddToStatusLog("Success to Re-Register.")
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnTryingToUnRegister()
        AddToStatusLog("Trying to Unregister.")
    End Sub

    Public Sub OnFailToUnRegister()
        AddToStatusLog("Fail to unregister.")
    End Sub

    Public Sub OnSuccessToUnRegister()
        AddToStatusLog("Unregistered successfully.")
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnDialCallStarted(ByVal nLineNo As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": Dialing.")
    End Sub

    Public Sub OnDialingCall(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": Response: " & sReasonPhrase)
    End Sub

    Public Sub OnConnectedCall(ByVal nLineNo As Integer)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": Success to connect.")
    End Sub

    Public Sub OnDialCallFailed(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": Response: " & sReasonPhrase)
    End Sub

    Public Sub OnHungupCall(ByVal nLineNo As Integer)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": Hang up.")
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnStatusMsg(ByVal nLineNo As Integer, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": " & sErrorMsg)
    End Sub

End Class
