﻿
Partial Public Class MainPhoneForm

    Private m_aLineVoice As cLineVoice()

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxVoiceOnline()

        Dim nTotalLine As Integer = m_objVaxUserAgent.GetTotalLine()
        m_aLineVoice = New cLineVoice(nTotalLine - 1) {}

        For nLineNo As Integer = 0 To nTotalLine - 1
            m_aLineVoice(nLineNo) = New cLineVoice()
        Next

        CheckLeftSpkListen.Checked = True
        CheckRightSpkListen.Checked = True

        CheckAllowListenConf.Checked = True
        CheckAllowSpeakConf.Checked = True

        CheckMuteLineSPK.Checked = False
        CheckMuteLineMIC.Checked = False

        SliderSpkVol.Value = 100
        SliderMicVol.Value = 100

        m_objVaxUserAgent.AudioDeviceVU(True, True, True)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxVoiceOffline()
        SpkProgBar.Value = 0
        MicProgBar.Value = 0
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckMuteLineSPK_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckMuteLineSPK.Click

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        Dim bResult As Boolean = m_objVaxUserAgent.MuteLineSpk(nLineNo, CheckMuteLineSPK.Checked)
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bMuteLineSPK = CheckMuteLineSPK.Checked

    End Sub

    Private Sub CheckMuteLineMIC_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckMuteLineMIC.Click

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        Dim bResult As Boolean = m_objVaxUserAgent.MuteLineMic(nLineNo, CheckMuteLineMIC.Checked)
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bMuteLineMIC = CheckMuteLineMIC.Checked

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckLeftSpkListen_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckLeftSpkListen.Click

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        If CheckLeftSpkListen.Checked = False AndAlso CheckRightSpkListen.Checked = False Then
            CheckRightSpkListen.Checked = True
        End If

        Dim bResult As Boolean = m_objVaxUserAgent.LineVoiceChannelSpk(nLineNo, SpkListenChannel(CheckLeftSpkListen.Checked, CheckRightSpkListen.Checked))
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bListenLeftSpk = CheckLeftSpkListen.Checked

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckRightSpkListen_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckRightSpkListen.Click

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        If CheckLeftSpkListen.Checked = False AndAlso CheckRightSpkListen.Checked = False Then
            CheckLeftSpkListen.Checked = True
        End If

        Dim bResult As Boolean = m_objVaxUserAgent.LineVoiceChannelSpk(nLineNo, SpkListenChannel(CheckLeftSpkListen.Checked, CheckRightSpkListen.Checked))
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bListenRightSpk = CheckRightSpkListen.Checked

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckAllowListenConf_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckAllowListenConf.Click

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        Dim bResult As Boolean = m_objVaxUserAgent.ConfAllowLine(nLineNo, CheckAllowListenConf.Checked, CheckAllowSpeakConf.Checked)
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bAllowListenConf = CheckAllowListenConf.Checked

    End Sub

    Private Sub CheckAllowSpeakConf_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckAllowSpeakConf.Click

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        Dim bResult As Boolean = m_objVaxUserAgent.ConfAllowLine(nLineNo, CheckAllowListenConf.Checked, CheckAllowSpeakConf.Checked)
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bAllowSpeakConf = CheckAllowSpeakConf.Checked

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckSpkMute_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckSpkMute.Click
        m_objVaxUserAgent.MuteSpk(CheckSpkMute.Checked)
    End Sub

    Private Sub CheckMuteMic_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CheckMuteMic.Click
        m_objVaxUserAgent.MuteMic(CheckMuteMic.Checked)
    End Sub

    Private Sub SliderSpkVol_Scroll(ByVal sender As Object, ByVal e As EventArgs) Handles SliderSpkVol.Scroll

        ' Value range (-100) --- 0 --- (+100)
        m_objVaxUserAgent.SetVolumeSpk(SliderSpkVol.Value - 100)

    End Sub

    Private Sub SliderMicVol_Scroll(ByVal sender As Object, ByVal e As EventArgs) Handles SliderMicVol.Scroll

        ' Value range (-100) --- 0 --- (+100)
        m_objVaxUserAgent.SetVolumeMic(SliderMicVol.Value - 100)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Function SpkListenChannel(ByVal bListenLeft As Boolean, ByVal bListenRight As Boolean) As Integer

        If bListenLeft = True AndAlso bListenRight = False Then
            Return 0
        End If

        If bListenLeft = False AndAlso bListenRight = True Then
            Return 1
        End If

        Return 2

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ListBoxLines_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles ListBoxLines.SelectedIndexChanged

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex
        If nLineNo = -1 Then Return

        CheckMuteLineMIC.Checked = m_aLineVoice(nLineNo).m_bMuteLineMIC
        CheckMuteLineSPK.Checked = m_aLineVoice(nLineNo).m_bMuteLineSPK

        CheckAllowListenConf.Checked = m_aLineVoice(nLineNo).m_bAllowListenConf
        CheckAllowSpeakConf.Checked = m_aLineVoice(nLineNo).m_bAllowSpeakConf

        CheckLeftSpkListen.Checked = m_aLineVoice(nLineNo).m_bListenLeftSpk
        CheckRightSpkListen.Checked = m_aLineVoice(nLineNo).m_bListenRightSpk

        UpdateBtnStatus()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnAudioDeviceMicVU(ByVal nLevelVU As Integer)
        MicProgBar.Value = nLevelVU
    End Sub

    Public Sub OnAudioDeviceSpkVU(ByVal nLevelVU As Integer)
        SpkProgBar.Value = nLevelVU
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

End Class

Public Class cLineVoice

    Public m_bMuteLineMIC As Boolean = False
    Public m_bMuteLineSPK As Boolean = False

    Public m_bAllowListenConf As Boolean = True
    Public m_bAllowSpeakConf As Boolean = True

    Public m_bListenLeftSpk As Boolean = True
    Public m_bListenRightSpk As Boolean = True

End Class
